namespace Adaptation.FileHandlers.QS408M;

#nullable enable

public class Body
{

    public Body(string waferMeanThickness, string stdDev, string passFail)
    {
        WaferMeanThickness = waferMeanThickness;
        StdDev = stdDev;
        PassFail = passFail;
    }

    public string WaferMeanThickness { get; }
    public string StdDev { get; }
    public string PassFail { get; }

    private static bool IsNullOrWhiteSpace(string text)
    {
        bool flag;
        int num = 0;
        while (true)
        {
            if (num >= text.Length)
            {
                flag = true;
                break;
            }
            else if (char.IsWhiteSpace(text[num]))
            {
                num++;
            }
            else
            {
                flag = false;
                break;
            }
        }
        return flag;
    }

    internal static string GetToken(string text, int[] i)
    {
        while (true)
        {
            if (i[0] >= text.Length || !IsNullOrWhiteSpace(text.Substring(i[0], 1)))
            {
                break;
            }
            i[0]++;
        }
        int num = i[0];
        while (true)
        {
            if (num >= text.Length || IsNullOrWhiteSpace(text.Substring(num, 1)))
            {
                break;
            }
            num++;
        }
        string str = text.Substring(i[0], num - i[0]);
        i[0] = num;
        return str.Trim();
    }

    internal static Body? Get(string text, int[] i)
    {
        Body? result;
        i[0] = Run.ScanPast(text, i, "mean thickness =");
        string meanThickness = Run.GetBefore(text, i, ", std. dev =");
        string stdDev = GetToken(text, i);
        string passFail = Run.GetToEOL(text, i);
        result = new(meanThickness,
                     stdDev,
                     passFail);
        return result;
    }

}